#include "raster_draw.h"

namespace raster { struct texture; }
namespace raster { struct solid_surf_desc; }
//
//  span block type
//
struct span_block
 {
  u32 * next;  // points to &spans[0] of next block;
  u32 spans[15];
 };



struct rend_data
{
  float z0;
  float dz[2];
  span_block * span_buf;  // linked list of blocks
};

struct rend_data_f0 : rend_data
{
  u32 color;  // rgb
};

struct rend_data_gour : rend_data
{
  //const solid_surf_desc * clut ;    // index
  const void * clut; 
  float sh0;
  float dsh[2];
};



struct rend_data_tex : rend_data
{
  const raster::texture * tmap;
  float sh0;
  float dsh[2];

  float u0;
  float du[2];

  float v0;
  float dv[2];
};

typedef void __fastcall std_fill_func(rend_data * _rd,u32 * end_span );

//
// knows fill func
//
struct rend_data_tex_fn : rend_data_tex
{
 std_fill_func * fill_func;
};


struct raster::poly
{
  poly * next; // next is in front of me
  poly * prev;

  u32 * cur_span;
  rend_data * dat;

 //	poly(void) { next = NULL; prev = NULL; cur_span = NULL; dat = NULL; }


  inline float z_at( float x, float y) { return dat->z0 + dat->dz[0]*x + dat->dz[1]*y; }

  inline void push_span(u32 span);
  inline void reset(rend_data * _dat);
};
